import axios from 'axios';
axios.create({ withCredentials: true, })

import nifti from 'nifti-reader-js'

const url = 'http://localhost:5000/api/'

class FileService {
  static getObjTree(projectId='',wd='/') {
    return new Promise(async (resolve,reject) => {
      try {
        const res = await axios.get(url+"filewatch/validate?id="+projectId, {withCredentials: true});
        const data = res.data;
        resolve(
          data
        )
      } catch (e) {
        reject(e)
      }
    })
  }

  static reloadObjTree(projectId='',wd='/') {
    // console.log('calling reload');
    return new Promise(async (resolve,reject) => {
      try {
        var res = await axios.get(url+"filewatch/clear?id="+projectId, {withCredentials: true});
        // console.log('done with clear');
        res = await this.getObjTree(projectId, wd);
        // console.log('done with getObjTree');
        // console.log(res);
        resolve(
          res
        )
      } catch (e) {
        console.log(e);
        reject(e)
      }
    })
  }

  static getFiles(projectId='',wd='/') {
    return new Promise(async (resolve,reject) => {
      try {
        const res = await axios.post(url+"filesystem/", {
          projectId,
          wd
        }, {withCredentials: true});
        const data = res.data;
        resolve(
          data
        )
      } catch (e) {
        reject(e)
      }
    })
  }
  static getFile(projectId='', wd='/', file='', type="") {
    return new Promise(async (resolve,reject) => {
      try {
        const res = await axios.post(url+"file/", {
          projectId,
          wd,
          file,
          type
        }, {withCredentials: true});
        var data = res.data;
        // console.log(typeof(data));
        // data = dat
        // console.log(res);
        // var d = nifti.Utils.toArrayBuffer(data);
        // var niftiHeader = nifti.readHeader();
        // console.log(niftiHeader.toFormattedString());

        // // var buffer = new ArrayBuffer(nifti.NIFTI1.STANDARD_HEADER_SIZE);
        // var buffer = nifti.Utils.toArrayBuffer(data.slice(0, nifti.NIFTI1.STANDARD_HEADER_SIZE-1));
        // console.log(buffer.byteLength + " vs " + nifti.NIFTI1.STANDARD_HEADER_SIZE);
        // var buf = new DataView(buffer);
        // var mag1 = buf.getUint8(nifti.NIFTI2.MAGIC_NUMBER_LOCATION);
        // var mag2 = buf.getUint8(nifti.NIFTI2.MAGIC_NUMBER_LOCATION + 1);
        // var mag3 = buf.getUint8(nifti.NIFTI2.MAGIC_NUMBER_LOCATION + 2);
        // console.log(!!((mag1 === nifti.NIFTI2.MAGIC_NUMBER[0]) && (mag2 === nifti.NIFTI2.MAGIC_NUMBER[1]) &&
        // (mag3 === nifti.NIFTI2.MAGIC_NUMBER[2])));
        // console.log(nifti.isNIFTI(buffer))
        // nifti.readHeader(nifti.Utils.toArrayBuffer(data.slice(0, nifti.NIFTI1.STANDARD_HEADER_SIZE)))
        resolve(
          data
        )
      } catch (e) {
        reject(e)
      }
    })
  }

}

export default FileService;
