import axios from 'axios';
axios.create({ withCredentials: true, })

const url = 'http://localhost:5000/'




class UserService {
  static login(email, password) {
    return new Promise(async (resolve,reject) => {
      const res = await axios.post(url+'login', {
        "email":email,
        "password":password
      }, {withCredentials: true});

      try {
        var user = await this.getUserDetails();
        // console.log('got user');
        // console.log(user);
        resolve(
          user
        )
      } catch (e) {
        reject(e)
      }
    })
  }

  static logout() {
    return new Promise(async (resolve,reject) => {

      try {
        const res = await axios.get(url+'logout', {withCredentials: true})
        var user = await this.getUserDetails();
        resolve(false)
      } catch (e) {
        resolve(false)
      }

    })

  }

  static getUserDetails() {
    return new Promise(async (resolve,reject) => {
      const res = await axios.get(url+"userdetails", {withCredentials: true});
      try {
        // console.log(res.data);
        // console.log('Reply from server:');
        // console.log(res);
        resolve(
          res.data
        )
      } catch (e) {
        reject(e)
      }
    })
  }
}

export default UserService;
