const express = require('express');
const router = express.Router();
const fs = require('fs')
const path = require('path')
const _ = require('lodash')
const nifti = require('nifti-reader-js')
var Blob = require('blob');

const projectfile=fs.readFileSync('server/projects.json', 'utf8'); // Todo: customization
const projects=JSON.parse(projectfile);



// router.get('/:projectId', async (req,res) => { //async (req,res) => (
//   // res.send('hello!');
//   var fs = await getFilesFromFolder( req.params.projectId ); //await getFilesFromFolder();
//   res.send(await fs);
// });

router.post( '/', async (req,res) => {
  try {
    var filepath = path.join(_.find(projects, [ 'id', req.body.projectId ]).path, req.body.wd, req.body.file);
    // console.log('Requesting ' + filepath );
    // console.log(req.body);
    var options = {
      dotfiles: 'deny',
      headers: {
          'x-timestamp': Date.now(),
          'x-sent': true
      }
    };

    switch(req.body.type) {
      case 'NIFTI':
        fs.readFile(filepath, (err, buf) => {
          if(typeof(buf)==='undefined') {
            // console.log(buf);
            res.send( [] );
            return;
          }
          var data = nifti.Utils.toArrayBuffer(buf)
          var niftiHeader = null,
              niftiImage = null,
              niftiExt = null;
          if (nifti.isCompressed(data)) {
              data = nifti.decompress(data);
          }
          if (nifti.isNIFTI(data)) {
              niftiHeader = nifti.readHeader(data);
              // console.log(niftiHeader.toFormattedString());
              niftiImage = nifti.readImage(niftiHeader, data);

              // if (nifti.hasExtension(niftiHeader)) {
              //     niftiExt = nifti.readExtensionData(niftiHeader, data);
              // }
              // console.log(niftiImage);
          }
          // var imageSize = niftiHeader.dims[1] * niftiHeader.dims[2] * niftiHeader.dims[3] * niftiHeader.dims[4] * (niftiHeader.numBitsPerVoxel / 8);
          //
          // var foo = niftiImage.slice(niftiHeader.vox_offset,niftiHeader.vox_offset+imageSize);
          // console.log(niftiImage.buffer);

          // niftiImageView = new DataView(niftiImage, 0);
          //
          // console.log(niftiHeader.toFormattedString());
          //
          // var dims = [112, 112, 15];
          // var range = [Infinity, -Infinity];
          // var slice = [];
          // // for(var i=dims[0]*dims[0]*7; i<dims[0]*dims[0]*8; i++) {
          // for(var i=dims[0]*dims[1]*dims[2]*0; i<dims[0]*dims[1]*dims[2]; i++) {
          // // for(var i=0; i<dims[0]*dims[1]*dims[2]/10; i++) {
          //   // console.log(nifti.Utils.getIntAt(niftiImageView,i));
          //   // var val = nifti.Utils.getIntAt(niftiImageView,i);
          //   var val = niftiImageView.getInt16(i);
          //   // console.log(val);
          //   // true ? range[0] = val : range[0] = range[0];
          //   // if(val <= -0) {
          //   //   val = 0;
          //   // }
          //   range[0] = ( range[0] > val ? val : range[0] );
          //   range[1] = ( range[1] < val ? val : range[1] );
          //   slice.push( val );
          // }
          // console.log(range);
          // // var minVal = Math.min( ...slice )
          // //     maxVal = Math.max( ...slice ) - Math.min( ...slice );
          // // console.log([Math.min( ...slice ), Math.max( ...slice )]);
          // // console.log(niftiImageView);
          //
          // slice = new Uint16Array(niftiImage, 0, niftiImageView.byteLength / 2);
          // console.log();
          // for(var i=0; i<slice.length; i++) {
          //   slice[i] = (slice[i]-range[0])/(range[1]-range[0]) * 255;
          //   // slice[i] = ( slice[i]<1 ? 255 : 0 );
          //   // console.log(slice);
          // }

          var dims = [ niftiHeader.dims[0],
                       niftiHeader.dims[1],
                       niftiHeader.dims[2],
                       niftiHeader.dims[3] ];

          var startSlice = 0;
          var reduced = false;
          if(dims[3]>48) {
            reduced = true;
            midSlice = Math.floor(dims[3]/2);

            // const slice1 = new Uint16Array(niftiImage, 0*dims[1]*dims[2]*2, dims[1]*dims[2]*dims[3]*1);
            var slice = new Uint16Array(niftiImage, midSlice*dims[1]*dims[2]*2, dims[1]*dims[2]*1);
            // const slice3 = new Uint16Array(niftiImage, (dims[3]-1)*dims[1]*dims[2]*2, dims[1]*dims[2]*1);
            dims[3] = 1;
            // var slice = new Uint16Array(slice1.length + slice2.length + slice3.length);
            // for (var i=0; i<slice1.length; i++)
            //     slice[i] = slice1[i];
            // for (var i=0; i<slice2.length; i++)
            //     slice[slice1.lenght+i] = slice2[i];
            // for (var i=0; i<slice3.length; i++)
            //     slice[slice1.lenght+slice2.lenght+i] = slice3[i];
          } else {
            var slice = new Uint16Array(niftiImage, startSlice*dims[1]*dims[2]*2, dims[1]*dims[2]*dims[3]);
          }


          // console.log(niftiHeader);

          var range = [Infinity, -Infinity];
          for(pos=0; pos<slice.length; pos++) {
            var val = slice[pos];
            range[0] = ( range[0] > val ? val : range[0] );
            range[1] = ( range[1] < val ? val : range[1] );
          }
          // slice = new Uint8Array
          // console.log(range);
          for(var pos=0; pos<slice.length; pos++) {
            slice[pos] = (slice[pos]-range[0])/(range[1]-range[0]) * 255;
          }

          res.send( {
            "header": niftiHeader,
            "headerString": niftiHeader.toFormattedString(),
            "dims": dims,
            "image": slice
          } )
          delete slice, data, niftiHeader, niftiImage;
        })
        break;
      default:
        // console.log('return default');
        res.sendFile(filepath, options, function (err) {
          if (err) {
            console.log('Error sending:', filepath);
            console.log(err)
            next(err);
          } else {
            console.log('Sent:', filepath);
          }
        });
    }
  } catch (e) {
    console.log(e)
    res.send( [] ) // Todo send better errors with HTTP codes
  }
});

    // const result = await getFile( req.body.projectId, req.body.wd, req.body.file );
    // res.send( result )
    // res.writeHead(200, {'Content-Type': 'application/nii'});
    // res.write(result,'binary');
    // res.end(undefined,'binary');
    // res.send( new Buffer(result, 'binary') )
    // res.download(filepath);
    // //       if (err) throw err;
          // console.log(buf)
    //       resolve(data);
    //     });
    // var data = // an ArrayBuffer



    // header reading works
    // var filepath = path.join(_.find(projects, [ 'id', req.body.projectId ]).path, req.body.wd, req.body.file)
    //
    //
    // fs.readFile(filepath, (err, buf) => {
    //
    //   var data = nifti.Utils.toArrayBuffer(buf)
    //   var niftiHeader = null,
    //       niftiImage = null,
    //       niftiExt = null;
    //
    //   if (nifti.isCompressed(data)) {
    //       data = nifti.decompress(data);
    //   }
    //
    //   if (nifti.isNIFTI(data)) {
    //       niftiHeader = nifti.readHeader(data);
    //       console.log(niftiHeader.toFormattedString());
    //       niftiImage = nifti.readImage(niftiHeader, data);
    //
    //       if (nifti.hasExtension(niftiHeader)) {
    //           niftiExt = nifti.readExtensionData(niftiHeader, data);
    //       }
    //
    //       console.log(niftiImage);
    //   }
    //
    // })




    // res.send(new Buffer(buf, 'binary'))
    // res.write(buf,'binary')
    // res.end(null, 'binary');
    // this works and can be used for file sending

  // //   // res.end(data, 'binary');



// async function getFile( projectId, wd, file ) {
//   // console.log(wd + file)
//   // console.log(path.join(_.find(projects, [ 'id', projectId ]).path, wd, file));
//   return new Promise(function (resolve, reject) {
//     // resolve( path.join(_.find(projects, [ 'id', projectId ]).path, wd, file) )
//     filepath = path.join(_.find(projects, [ 'id', projectId ]).path, wd, file)
//     fs.readFile(filepath, (err, data) => {
//       if (err) {
//         reject(err);
//       }
//       // console.log(data);
//       // console.log(nifti.isNIFTI(nifti.Utils.toArrayBuffer(data)));
//       resolve(data);
//     });
//   });
//   // return 'hello world!'
// }

module.exports = router;
